"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Dataset(ProtocolElement):
    """
    Represents a group of contextually related data objects of (e.g. all
    Individuals, Samples,  Experiments associated with a particular
    feature; or e.g. a trio in genetic diagnostics.). This concept may
    be expanded in the future (ontology for describing the type of
    dataset ...). TODO: Determination of scope, structure, specific
    attributes, e.g. limiting to single  record type - see
    http://purl.obolibrary.org/obo/IAO_0000100 - and providing
    alternative mechanism  for heterogeneous data with external
    contextualization, e.g. all records of different  types associated
    with a clinical study.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2_1 import ga4gh as ga4gh_3_0_0

        return {
            "org.ga4gh.models.Dataset": ga4gh_3_0_0.Dataset,
        }

    __slots__ = [
        "id",
        "description",
    ]

    def __init__(
        self,
        id,
        description=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_0_0.Dataset model.

        :param id:
            The dataset UUID. This is globally unique.
        :type id: str
        :param description:
            A description of the dataset.
        :type description: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
